"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = useValidator;

var _moment = _interopRequireDefault(require("moment"));

var _react = _interopRequireWildcard(require("react"));

var _rules = require("./rules.js");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function useValidator(InitialValues, DefaultTab) {
  var _useState = (0, _react.useState)(function () {
    if (undefined !== DefaultTab) {
      var _initState = {
        errors: {},
        info: {},
        inputs: {}
      };

      for (var tabKey in InitialValues) {
        var inputs = InitialValues[tabKey];

        for (var name in inputs) {
          _initState.errors[name] = {};
          _initState.info[name] = {
            active: false,
            interacted: false,
            tab: tabKey
          };
          _initState.inputs[name] = inputs[name];
        }
      }

      return _initState;
    }

    var initState = {
      errors: {},
      info: {},
      inputs: _objectSpread({}, InitialValues)
    };

    for (var key in InitialValues) {
      initState.errors[key] = {};
      initState.info[key] = {
        active: false,
        interacted: false
      };
    }

    return initState;
  }),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var _useState3 = (0, _react.useState)(DefaultTab),
      _useState4 = _slicedToArray(_useState3, 2),
      tab = _useState4[0],
      setTab = _useState4[1];

  var gerFirstInputError = function gerFirstInputError() {
    for (var inputKey in state.errors) {
      for (var ruleKey in state.errors[inputKey]) {
        if (state.errors[inputKey][ruleKey]) {
          return inputKey;
        }
      }
    }

    return undefined;
  };

  var handleCheckboxChange = function handleCheckboxChange(name, onChange) {
    return function (event) {
      setState(function (oldState) {
        oldState.info[name].interacted = true;
        oldState.inputs[name] = !oldState.inputs[name];
        return _objectSpread({}, oldState);
      });

      if (undefined !== onChange) {
        for (var _len = arguments.length, props = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          props[_key - 1] = arguments[_key];
        }

        onChange.apply(void 0, [event].concat(props));
      }
    };
  };

  var handleDatePickerChange = function handleDatePickerChange(name, onChange, dateFormat, timeFormat) {
    return function (value) {
      var newValue = value;

      if ("object" === _typeof(value) && undefined === value._f) {
        newValue._f = "";

        if ("string" === typeof dateFormat) {
          newValue._f += dateFormat;
        } else if (undefined === dateFormat || true === dateFormat) {
          newValue._f += _moment["default"].localeData().longDateFormat("L");
        }

        if ("string" === typeof timeFormat) {
          newValue._f += (0 < newValue._f.length ? " " : "") + timeFormat;
        } else if (undefined === timeFormat || true === timeFormat) {
          newValue._f += (0 < newValue._f.length ? " " : "") + _moment["default"].localeData().longDateFormat("LT");
        }
      }

      setState(function (oldState) {
        oldState.info[name].interacted = true;
        oldState.inputs[name] = newValue || null;
        return _objectSpread({}, oldState);
      });

      if (undefined !== onChange) {
        for (var _len2 = arguments.length, props = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          props[_key2 - 1] = arguments[_key2];
        }

        onChange.apply(void 0, [newValue].concat(props));
      }
    };
  };

  var handleInputBlur = function handleInputBlur(name, onBlur) {
    return function () {
      setState(function (oldState) {
        oldState.info[name].active = false;
        return _objectSpread({}, oldState);
      });

      if (undefined !== onBlur) {
        onBlur.apply(void 0, arguments);
      }
    };
  };

  var handleInputChange = function handleInputChange(name, onChange) {
    return function (event) {
      var _ref;

      for (var _len3 = arguments.length, props = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        props[_key3 - 1] = arguments[_key3];
      }

      var newValue = (_ref = props[0] && props[0].value) !== null && _ref !== void 0 ? _ref : event.currentTarget.value;
      setState(function (oldState) {
        oldState.inputs[name] = newValue;
        return _objectSpread({}, oldState);
      });

      if (undefined !== onChange) {
        onChange.apply(void 0, [event].concat(props));
      }
    };
  };

  var handleInputFocus = function handleInputFocus(name, onFocus) {
    return function () {
      setState(function (oldState) {
        oldState.info[name].active = true;
        oldState.info[name].interacted = true;
        return _objectSpread({}, oldState);
      });

      if (undefined !== onFocus) {
        onFocus.apply(void 0, arguments);
      }
    };
  };

  var handleRadioChange = function handleRadioChange(name, value, onChange) {
    return function (event) {
      setState(function (oldState) {
        oldState.info[name].interacted = true;
        oldState.inputs[name] = value;
        return _objectSpread({}, oldState);
      });

      if (undefined !== onChange) {
        for (var _len4 = arguments.length, props = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          props[_key4 - 1] = arguments[_key4];
        }

        onChange.apply(void 0, [event].concat(props));
      }
    };
  };

  var handleSubmit = function handleSubmit(onSuccess, onError) {
    return function () {
      var errorInputKey = gerFirstInputError();

      if (undefined !== errorInputKey) {
        if ("function" === typeof onError) {
          onError.apply(void 0, arguments);
        }

        setState(function (oldState) {
          for (var inputKey in oldState.info) {
            oldState.info[inputKey].interacted = true;
          }

          return _objectSpread({}, oldState);
        });

        if (undefined !== DefaultTab) {
          setTab(state.info[errorInputKey].tab);
        }
      } else {
        if ("function" === typeof onSuccess) {
          onSuccess.apply(void 0, arguments);
        }
      }
    };
  };

  var importCheckbox = function importCheckbox(Name) {
    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        OnChange = _ref2.onChange;

    return {
      checked: state.inputs[Name],
      name: Name.toLowerCase(),
      onChange: handleCheckboxChange(Name, OnChange)
    };
  };

  var importDatePicker = function importDatePicker(Name) {
    var _ref3 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        DateFormat = _ref3.dateFormat,
        OnBlur = _ref3.onBlur,
        OnChange = _ref3.onChange,
        OnFocus = _ref3.onFocus,
        TimeFormat = _ref3.timeFormat;

    return {
      dateFormat: DateFormat,
      name: Name.toLowerCase(),
      onBlur: handleInputBlur(Name, OnBlur),
      onChange: handleDatePickerChange(Name, OnChange, DateFormat, TimeFormat),
      onFocus: handleInputFocus(Name, OnFocus),
      timeFormat: TimeFormat,
      value: state.inputs[Name]
    };
  };

  var importRadio = function importRadio(Name, Value) {
    var _ref4 = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
        onChange = _ref4.onChange;

    return {
      checked: Value === state.inputs[Name],
      name: Name.toLowerCase(),
      onChange: handleRadioChange(Name, Value, onChange)
    };
  };

  var importInput = function importInput(Name) {
    var _ref5 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        OnBlur = _ref5.onBlur,
        OnChange = _ref5.onChange,
        OnFocus = _ref5.onFocus;

    return {
      name: Name.toLowerCase(),
      onBlur: handleInputBlur(Name, OnBlur),
      onChange: handleInputChange(Name, OnChange),
      onFocus: handleInputFocus(Name, OnFocus),
      value: state.inputs[Name]
    };
  };

  var importSubmit = function importSubmit(_ref6) {
    var OnError = _ref6.onError,
        OnSuccess = _ref6.onSuccess;
    return {
      onClick: handleSubmit(OnSuccess, OnError)
    };
  };

  var setInputs = function setInputs(callback) {
    setState(function (oldState) {
      return _objectSpread(_objectSpread({}, oldState), {}, {
        inputs: callback(oldState.inputs)
      });
    });
  };

  var IsEmail = function IsEmail(_ref7) {
    var Children = _ref7.children,
        _ref7$enabled = _ref7.enabled,
        Enabled = _ref7$enabled === void 0 ? true : _ref7$enabled,
        For = _ref7["for"];
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isEmail(value);
        var wasError = undefined !== oldState.errors[For].IsEmail;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsEmail = true;
        } else {
          delete oldState.errors[For].IsEmail;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsEmail && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsEqual = function IsEqual(_ref8) {
    var Children = _ref8.children,
        _ref8$enabled = _ref8.enabled,
        Enabled = _ref8$enabled === void 0 ? true : _ref8$enabled,
        For = _ref8["for"],
        Value = _ref8.value;
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isEqual(value, Value);
        var wasError = undefined !== oldState.errors[For].IsEqual;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsEqual = true;
        } else {
          delete oldState.errors[For].IsEqual;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsEqual && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsInRange = function IsInRange(_ref9) {
    var Children = _ref9.children,
        _ref9$enabled = _ref9.enabled,
        Enabled = _ref9$enabled === void 0 ? true : _ref9$enabled,
        For = _ref9["for"],
        _ref9$range = _slicedToArray(_ref9.range, 2),
        min = _ref9$range[0],
        max = _ref9$range[1];

    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isInRange(value, [min, max]);
        var wasError = undefined !== oldState.errors[For].IsInRange;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsInRange = true;
        } else {
          delete oldState.errors[For].IsInRange;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsInRange && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsLengthValid = function IsLengthValid(_ref10) {
    var Children = _ref10.children,
        _ref10$enabled = _ref10.enabled,
        Enabled = _ref10$enabled === void 0 ? true : _ref10$enabled,
        For = _ref10["for"],
        _ref10$length = _slicedToArray(_ref10.length, 2),
        min = _ref10$length[0],
        max = _ref10$length[1];

    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isLengthValid(value, [min, max]);
        var wasError = undefined !== oldState.errors[For].IsLengthValid;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsLengthValid = true;
        } else {
          delete oldState.errors[For].IsLengthValid;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsLengthValid && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsMomentValid = function IsMomentValid(_ref11) {
    var Children = _ref11.children,
        _ref11$enabled = _ref11.enabled,
        Enabled = _ref11$enabled === void 0 ? true : _ref11$enabled,
        For = _ref11["for"];
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isMomentValid(value);
        var wasError = undefined !== oldState.errors[For].IsMomentValid;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsMomentValid = true;
        } else {
          delete oldState.errors[For].IsMomentValid;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsMomentValid && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsNumber = function IsNumber(_ref12) {
    var Children = _ref12.children,
        _ref12$enabled = _ref12.enabled,
        Enabled = _ref12$enabled === void 0 ? true : _ref12$enabled,
        For = _ref12["for"];
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isNumber(value);
        var wasError = undefined !== oldState.errors[For].IsNumber;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsNumber = true;
        } else {
          delete oldState.errors[For].IsNumber;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsNumber && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var IsValid = function IsValid(_ref13) {
    var Children = _ref13.children,
        _ref13$enabled = _ref13.enabled,
        Enabled = _ref13$enabled === void 0 ? true : _ref13$enabled,
        For = _ref13["for"],
        Pattern = _ref13.pattern;
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.isValid(value, Pattern);
        var wasError = undefined !== oldState.errors[For].IsValid;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].IsValid = true;
        } else {
          delete oldState.errors[For].IsValid;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].IsValid && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var Required = function Required(_ref14) {
    var Children = _ref14.children,
        _ref14$enabled = _ref14.enabled,
        Enabled = _ref14$enabled === void 0 ? true : _ref14$enabled,
        For = _ref14["for"];
    (0, _react.useEffect)(function () {
      setState(function (oldState) {
        var value = state.inputs[For];
        var hasError = Enabled && !_rules.rules.required(value);
        var wasError = undefined !== oldState.errors[For].Required;

        if (hasError === wasError) {
          return oldState;
        }

        if (hasError) {
          oldState.errors[For].Required = true;
        } else {
          delete oldState.errors[For].Required;
        }

        return _objectSpread({}, oldState);
      });
    }, [Enabled, state.inputs[For]]);

    if (state.errors[For].Required && !state.info[For].active && state.info[For].interacted) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, Children);
    }

    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  var Validator = (0, _react.useMemo)(function () {
    return {
      importCheckbox: importCheckbox,
      importDatePicker: importDatePicker,
      importInput: importInput,
      importRadio: importRadio,
      importSubmit: importSubmit,
      IsEmail: IsEmail,
      IsEqual: IsEqual,
      IsInRange: IsInRange,
      IsLengthValid: IsLengthValid,
      IsMomentValid: IsMomentValid,
      IsNumber: IsNumber,
      IsValid: IsValid,
      Required: Required
    };
  }, []);
  return {
    inputs: state.inputs,
    tab: tab,
    setInputs: setInputs,
    setTab: setTab,
    Validator: Validator
  };
}