"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rules = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var rules = {
  isEmail: function isEmail(value) {
    return undefined === value || 0 === value.length || /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(String(value).toLowerCase());
  },
  isEqual: function isEqual(value, target) {
    return undefined === value || 0 === value.length || target === value;
  },
  isInRange: function isInRange(value, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        min = _ref2[0],
        max = _ref2[1];

    return undefined === value || 0 === value.length || value >= min && value <= max;
  },
  isLengthValid: function isLengthValid(value, _ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        min = _ref4[0],
        max = _ref4[1];

    return undefined === value || 0 === value.length || min <= value.length && max >= value.length;
  },
  isMomentValid: function isMomentValid(value) {
    return undefined === value || null === value || 0 === value.length || undefined !== value.isValid && value.isValid();
  },
  isNumber: function isNumber(value) {
    return undefined === value || 0 === value.length || !Number.isNaN(Number(value));
  },
  isValid: function isValid(value, pattern) {
    var regex = new RegExp(pattern);
    return regex.test(value);
  },
  required: function required(value) {
    return undefined !== value && null !== value && false !== value && 0 !== value.length;
  }
};
exports.rules = rules;